Subject: Re: Command-line git Vs IDE+plugin?

From: Thomas Koch <[email-masked]>
Date: Tue, 19 Nov 2013 13:36:30 +0100

On Monday, November 18, 2013 06:11:54 PM Matthieu Moy wrote:
> Hi,
> 
> I'm normally an Emacs+command-line user, but I also use Eclipse or
> Netbeans on some projects. I tried using EGit and the Netbeans plugin
> for Git, but found the GUI both more comlex and less powerful than the
> command-line. I end-up using command-line git in a terminal, outside the
> IDE (and do a refresh in the IDE after commands that modify the
> worktree). Obviously, being a long-time command-line user, I'm rather
> heavily biaised ;-).
> 
> I was wondering whether others had similar (or not) experience. In
> particular, as a teacher, I'm wondering whether I should push my
> students towards the GUI in the IDE, or advise them to keep using the
> command-line (we teach them git with the command-line first anyway, but
> after a year of practice, we may want to show them the GUI equivalent).

I'm a software engineer now with an education as a high school teacher. From a 
theoretical point of view it's preferable to avoid any abstraction done by a 
GUI and use commandline Git. Only gitk is useful to have a visual _feedback_ 
of the actions done on the commandline.

But also from experience I can tell that without exception everybody whom I 
teached Git understood it only after being introduced to the basic concepts of 
Git and how to inspect and operate them on the commandline. Others told me 
from similar experiences.

Those concepts are:

- hashes
- content adressable storage
- blops being referenced by trees being referenced by commits

My collegues meanwhile dumped their graphical Git tool because they learned 
that they have better control over Git when using it from the commandline.

Regards, Thomas Koch